<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/28/2009 *
 * ===============                              Last change: 02/28/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : hooks.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Hooks (call-backs)                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Hooks (Call-Back)                                *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Call-back function for running shutdown functions and close database connection
function __SHUTDOWN_HOOK () {
	// Call the filter chain 'shutdown'
	RUN_FILTER('shutdown', null, false);

	if (SQL_IS_LINK_UP()) {
		// Close link
		SQL_CLOSE(__FILE__, __LINE__);
	} else {
		// No database link
		addFatalMessage(getMessage('NO_DB_LINK'));
	}
}

// [EOF]
?>
