<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/22/2004 *
 * ================                             Last change: 09/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_home.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Set "home" page                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : "Home"-Seite festlegen                           *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

$sub = "";
if (REQUEST_ISSET_GET(('sub'))) $sub = REQUEST_GET('sub');

switch ($sub)
{
case "": // Output selection table
	LOAD_TEMPLATE("admin_config_home_main");
	break;

case "settings": // Settings related to the index page
	if (IS_FORM_SENT()) {
		// Save settings
		ADMIN_SAVE_SETTINGS_POST();
		OUTPUT_HTML("<a href=\"{!URL!}/modules.php?module=admin&amp;what=config_home&amp;sub=settings\">".ADMIN_CONTINUE_TO_CONFIG."</a>");
	} else {
		// Prepare data for the template
		$content = array_fill(-1, 60, "");
		$content[getConfig('index_delay')] = " selected=\"selected\"";

		define('__INDEX_COOKIE_SELECTION', CREATE_TIME_SELECTIONS(getConfig('index_cookie'), "index_cookie", "YMWD"));
		LOAD_TEMPLATE("admin_config_home_settings", false, $content);
	}
	break;

case "target": // Set which what-file will be placed in home-page (only modules.php?module=index)
	if (REQUEST_ISSET_GET(('home'))) {
		// Set new home
		UPDATE_CONFIG("index_home", SQL_ESCAPE(REQUEST_GET('home')));
	} // END - if

	// Load all what menu points
	$result = SQL_QUERY("SELECT id, what, title
FROM `{!_MYSQL_PREFIX!}_guest_menu`
WHERE `action`='main' AND `what` != '' AND `what` IS NOT NULL AND `locked`='N'
ORDER BY `sort` ASC", __FILE__, __LINE__);

	$SW = 2; $OUT = ""; $atitle = "";
	while (list($id, $wht, $wtitle) = SQL_FETCHROW($result)) {
		$LINK = "<a href=\"{!URL!}/modules.php?module=admin&amp;what=config_home&amp;sub=target&amp;home=".$wht."\">"._IS_NEW_HOME."</a>";
		if ($wht == getConfig('index_home')) {
			// Is current home
			$LINK   = "<div class=\"admin_note\">{!_IS_CURRENT_HOME!}</div>";
			$atitle = "<div class=\"admin_note\">".$atitle."</div>";
			$wtitle = "<div class=\"admin_note\">".$wtitle."</div>";
		}

		// Add row...
		$OUT .= "<tr>
	  <td class=\"switch_sw".$SW." bottom right\">&nbsp;".$id."</td>
	  <td class=\"switch_sw".$SW." bottom right\">&nbsp;".$wtitle."</td>
	  <td class=\"switch_sw".$SW." bottom\" align=\"center\">
	    ".$LINK."
	  </td>
	</tr>\n";

		// Switch color
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);
	define('__HOME_ROWS', $OUT);

	// Load template
	LOAD_TEMPLATE("admin_config_home");
	break;
}

//
?>
